def evaluate(t, v):
    op = t[0]
    if op == "int":     return          t[1]
    if op == "id":      return        v[t[1]]
    if op == "mod":     return evaluate(t[1], v) % evaluate(t[2], v)
    if op == "div":     return evaluate(t[1], v) / evaluate(t[2], v)
    if op == "mul":     return evaluate(t[1], v) * evaluate(t[2], v)
    if op == "sub":     return evaluate(t[1], v) - evaluate(t[2], v)
    if op == "add":     return evaluate(t[1], v) + evaluate(t[2], v)
    if op == "less":    return evaluate(t[1], v) < evaluate(t[2], v)
    if op == "assign":
        lhs = t[1][1]
        rhs = evaluate(t[2], v)
        v[lhs] = rhs
        return rhs
    if op == "print":
        value = evaluate(t[1], v)
        print(value)
        return value
    if op == "while":
        condition = t[1]
        body = t[2]
        value = 0
        while (evaluate(condition, v) != 0): value= evaluate(body, v)
        return value
    print("\nI do not grok: " + str(op))
    exit()

def find_input():
    try:
        return raw_input
    except:
        return input

raw_input = find_input()

env = {} # variables

while True:
    try:
        ast = eval(raw_input())
        print("\t" + str(ast))
        val = evaluate(ast, env)
        print(val)
    except EOFError:
        break
